;*******************************************Check Collision Enemy1 Vs Vexp
;*
;*	Clecks the collision of enemy1 and verticle explosion
;*
;********
col_en1_vs_vexp:
	movem.l		d0-d7/a0-a3,-(a7)
	move.w	bomblib::plx,d0
	move.w	bomblib::ply,d1

	move.w	bomblib::vexpcount,d7
	cmp.w	#0,d7
	ble		end_col_en1_vs_vexp_loop_2
	subq.w	#1,d7

	col_en1_vs_vexp_loop_2:
		move.w	d7,d6
		lea	bomblib::vexp_x,a0		;Get enemy d6's x
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a2
		lea	bomblib::vexp_y,a0		;Get enemy d6's y
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a3
		move.w	(a2),d0
		move.w	(a3),d1

		movem.l		d6-d7,-(a7)

			move.w	bomblib::enemy1count,d7
			cmp.w	#0,d7
			ble		end_col_en1_vs_vexp_loop_1
			subq.w	#1,d7

			col_en1_vs_vexp_loop_1:
				move.w	d7,d6
				lea	bomblib::enemy1_x,a0		;Get enemy d6's x
				move.w  d6,d2
				mulu.w	#2,d2
				lea	0(a0,d2.w),a2
				lea	bomblib::enemy1_y,a0		;Get enemy d6's y
				move.w  d6,d2
				mulu.w	#2,d2
				lea	0(a0,d2.w),a3
				move.w	(a2),d2
				move.w	(a3),d3

				move.w	d0,d4
				move.w	d2,d5
				subq.w	#3,d4
				addq.w	#3,d5
				cmp.w	d4,d5
				bcs		col_en1_vs_vexp_no_col

				move.w	d0,d4
				move.w	d2,d5
				addq.w	#3,d4
				subq.w	#3,d5
				cmp.w	d4,d5
				bhi		col_en1_vs_vexp_no_col

				move.w	d1,d4
				move.w	d3,d5
				subq.w	#4,d4
				addq.w	#3,d5
				cmp.w	d4,d5
				bcs		col_en1_vs_vexp_no_col

				move.w	d1,d4
				move.w	d3,d5
				addq.w	#4,d4
				subq.w	#3,d5
				cmp.w	d4,d5
				bhi		col_en1_vs_vexp_no_col

					jsr		bomblib::delete_enemy1
					add.w	#100,bomblib::score
					bsr		draw_score

				col_en1_vs_vexp_no_col:

				dbra.w	d7,col_en1_vs_vexp_loop_1
			end_col_en1_vs_vexp_loop_1:

		movem.l		(a7)+,d6-d7
		dbra.w	d7,col_en1_vs_vexp_loop_2
	end_col_en1_vs_vexp_loop_2:

	movem.l		(a7)+,d0-d7/a0-a3
	rts

;*******************************************Check Collision Enemy1 Vs Hexp
;*
;*	Clecks the collision of enemy1 and horizontal explosion
;*
;********
col_en1_vs_hexp:
	movem.l		d0-d7/a0-a3,-(a7)
	move.w	bomblib::plx,d0
	move.w	bomblib::ply,d1

	move.w	bomblib::hexpcount,d7
	cmp.w	#0,d7
	ble		end_col_en1_vs_hexp_loop_2
	subq.w	#1,d7

	col_en1_vs_hexp_loop_2:
		move.w	d7,d6
		lea	bomblib::hexp_x,a0		;Get enemy d6's x
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a2
		lea	bomblib::hexp_y,a0		;Get enemy d6's y
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a3
		move.w	(a2),d0
		move.w	(a3),d1

		movem.l		d6-d7,-(a7)

			move.w	bomblib::enemy1count,d7
			cmp.w	#0,d7
			ble		end_col_en1_vs_hexp_loop_1
			subq.w	#1,d7

			col_en1_vs_hexp_loop_1:
				move.w	d7,d6
				lea	bomblib::enemy1_x,a0		;Get enemy d6's x
				move.w  d6,d2
				mulu.w	#2,d2
				lea	0(a0,d2.w),a2
				lea	bomblib::enemy1_y,a0		;Get enemy d6's y
				move.w  d6,d2
				mulu.w	#2,d2
				lea	0(a0,d2.w),a3
				move.w	(a2),d2
				move.w	(a3),d3

				move.w	d0,d4
				move.w	d2,d5
				subq.w	#4,d4
				addq.w	#3,d5
				cmp.w	d4,d5
				bcs		col_en1_vs_hexp_no_col

				move.w	d0,d4
				move.w	d2,d5
				addq.w	#4,d4
				subq.w	#3,d5
				cmp.w	d4,d5
				bhi		col_en1_vs_hexp_no_col

				move.w	d1,d4
				move.w	d3,d5
				subq.w	#3,d4
				addq.w	#3,d5
				cmp.w	d4,d5
				bcs		col_en1_vs_hexp_no_col

				move.w	d1,d4
				move.w	d3,d5
				addq.w	#3,d4
				subq.w	#3,d5
				cmp.w	d4,d5
				bhi		col_en1_vs_hexp_no_col

					jsr		bomblib::delete_enemy1
					add.w	#100,bomblib::score
					bsr		draw_score

				col_en1_vs_hexp_no_col:

				dbra.w	d7,col_en1_vs_hexp_loop_1
			end_col_en1_vs_hexp_loop_1:

		movem.l		(a7)+,d6-d7
		dbra.w	d7,col_en1_vs_hexp_loop_2
	end_col_en1_vs_hexp_loop_2:

	movem.l		(a7)+,d0-d7/a0-a3
	rts

;*******************************************Check Collision Me Vs Vexp
;*
;*	Clecks the collision of player and verticle explosion
;*
;********
col_me_vs_vexp:
	movem.l		d0-d7/a0-a3,-(a7)
	move.w	bomblib::plx,d0
	move.w	bomblib::ply,d1

	move.w	bomblib::vexpcount,d7
	cmp.w	#0,d7
	ble		end_col_me_vs_vexp_loop_1
	subq.w	#1,d7

	col_me_vs_vexp_loop_1:
		move.w	d7,d6
		lea	bomblib::vexp_x,a0		;Get enemy d6's x
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a2
		lea	bomblib::vexp_y,a0		;Get enemy d6's y
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a3
		move.w	(a2),d2
		move.w	(a3),d3

		move.w	d0,d4
		move.w	d2,d5
		subq.w	#4,d4
		addq.w	#3,d5
		cmp.w	d4,d5
		bcs		col_me_vs_vexp_no_col

		move.w	d0,d4
		move.w	d2,d5
		addq.w	#4,d4
		subq.w	#3,d5
		cmp.w	d4,d5
		bhi		col_me_vs_vexp_no_col

		move.w	d1,d4
		move.w	d3,d5
		subq.w	#4,d4
		addq.w	#4,d5
		cmp.w	d4,d5
		bcs		col_me_vs_vexp_no_col

		move.w	d1,d4
		move.w	d3,d5
		addq.w	#4,d4
		subq.w	#4,d5
		cmp.w	d4,d5
		bhi		col_me_vs_vexp_no_col

			movem.l		(a7)+,d0-d7/a0-a3
			bra		i_have_died

		col_me_vs_vexp_no_col:

		dbra.w	d7,col_me_vs_vexp_loop_1
	end_col_me_vs_vexp_loop_1:

	movem.l		(a7)+,d0-d7/a0-a3
	rts

;*******************************************Check Collision Me Vs Hexp
;*
;*	Clecks the collision of enemy1 and horizontal explosion
;*
;********
col_me_vs_hexp:
	movem.l		d0-d7/a0-a3,-(a7)
	move.w	bomblib::plx,d0
	move.w	bomblib::ply,d1

	move.w	bomblib::hexpcount,d7
	cmp.w	#0,d7
	ble		end_col_me_vs_hexp_loop_1
	subq.w	#1,d7

	col_me_vs_hexp_loop_1:
		move.w	d7,d6
		lea	bomblib::hexp_x,a0		;Get enemy d6's x
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a2
		lea	bomblib::hexp_y,a0		;Get enemy d6's y
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a3
		move.w	(a2),d2
		move.w	(a3),d3

		move.w	d0,d4
		move.w	d2,d5
		subq.w	#4,d4
		addq.w	#4,d5
		cmp.w	d4,d5
		bcs		col_me_vs_hexp_no_col

		move.w	d0,d4
		move.w	d2,d5
		addq.w	#4,d4
		subq.w	#4,d5
		cmp.w	d4,d5
		bhi		col_me_vs_hexp_no_col

		move.w	d1,d4
		move.w	d3,d5
		subq.w	#4,d4
		addq.w	#3,d5
		cmp.w	d4,d5
		bcs		col_me_vs_hexp_no_col

		move.w	d1,d4
		move.w	d3,d5
		addq.w	#4,d4
		subq.w	#3,d5
		cmp.w	d4,d5
		bhi		col_me_vs_hexp_no_col

			movem.l		(a7)+,d0-d7/a0-a3
			bra		i_have_died

		col_me_vs_hexp_no_col:

		dbra.w	d7,col_me_vs_hexp_loop_1
	end_col_me_vs_hexp_loop_1:

	movem.l		(a7)+,d0-d7/a0-a3
	rts

;*******************************************Check Collision Me Vs Bonus
;*
;*	Clecks the collision of player and bonus
;*
;********
col_me_vs_bonus:
	movem.l		d0-d7/a0-a4,-(a7)
	move.w	bomblib::plx,d0
	move.w	bomblib::ply,d1

	move.w	bomblib::bonuscount,d7
	cmp.w	#0,d7
	ble		end_col_me_vs_bonus_loop_1
	subq.w	#1,d7

	col_me_vs_bonus_loop_1:
		move.w	d7,d6
		lea	bomblib::bonus_x,a0		;Get enemy d6's x
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a2
		lea	bomblib::bonus_y,a0		;Get enemy d6's y
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a3
		lea	bomblib::bonus_t,a0		;Get enemy d6's t
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a4
		move.w	(a2),d2
		move.w	(a3),d3
		move.w	(a4),t

		move.w	d0,d4
		move.w	d2,d5
		subq.w	#4,d4
		addq.w	#4,d5
		cmp.w	d4,d5
		bcs		col_me_vs_bonus_no_col

		move.w	d0,d4
		move.w	d2,d5
		addq.w	#4,d4
		subq.w	#4,d5
		cmp.w	d4,d5
		bhi		col_me_vs_bonus_no_col

		move.w	d1,d4
		move.w	d3,d5
		subq.w	#4,d4
		addq.w	#3,d5
		cmp.w	d4,d5
		bcs		col_me_vs_bonus_no_col

		move.w	d1,d4
		move.w	d3,d5
		addq.w	#4,d4
		subq.w	#3,d5
		cmp.w	d4,d5
		bhi		col_me_vs_bonus_no_col

			bsr		delete_bonus
			add.w	#50,bomblib::score
			bsr		draw_score
			move.w	t,d4
			cmp.w	#0,d4
			beq		col_me_vs_bonus_t1
			cmp.w	#1,d4
			beq		col_me_vs_bonus_t2
			cmp.w	#2,d4
			beq		col_me_vs_bonus_t3
			cmp.w	#3,d4
			beq		col_me_vs_bonus_t4
			cmp.w	#4,d4
			beq		col_me_vs_bonus_t5
			cmp.w	#5,d4
			beq		col_me_vs_bonus_t6
			cmp.w	#6,d4
			beq		col_me_vs_bonus_t7
			cmp.w	#7,d4
			beq		col_me_vs_bonus_t8
			cmp.w	#8,d4
			beq		col_me_vs_bonus_t9
			bra		col_me_vs_bonus_no_col

			col_me_vs_bonus_t1:
				cmp.w	#5,bomblib::bombsallowed
				beq		col_me_vs_bonus_no_col
				addq.w	#1,bomblib::bombsallowed
				bra		col_me_vs_bonus_no_col

			col_me_vs_bonus_t2:
				cmp.w	#4,bomblib::pllife
				beq		col_me_vs_bonus_no_col
				addq.w	#1,bomblib::pllife
				bsr		draw_life
				bra		col_me_vs_bonus_no_col

			col_me_vs_bonus_t3:
				cmp.w	#4,bomblib::def_t_to_key
				ble		col_me_vs_bonus_no_col
				subq.w	#1,bomblib::def_t_to_key
				bra		col_me_vs_bonus_no_col

			col_me_vs_bonus_t4:
				cmp.w	#5,bomblib::bomb_exp_len
				beq		col_me_vs_bonus_no_col
				addq.w	#1,bomblib::bomb_exp_len
				bra		col_me_vs_bonus_no_col

			col_me_vs_bonus_t5:
				move.w	#1,bomblib::trigger_bombs
				bra		col_me_vs_bonus_no_col

			col_me_vs_bonus_t6:
				move.w	#5,bomblib::bomb_exp_len
				bra		col_me_vs_bonus_no_col

			col_me_vs_bonus_t7:
				add.w	#250,bomblib::score
				bra		col_me_vs_bonus_no_col

			col_me_vs_bonus_t8:
				move.w	#1,bomblib::walk_through_walls
				bra		col_me_vs_bonus_no_col

			col_me_vs_bonus_t9:
				move.w	#1,bomblib::walk_through_bombs
				bra		col_me_vs_bonus_no_col

		col_me_vs_bonus_no_col:

		dbra.w	d7,col_me_vs_bonus_loop_1
	end_col_me_vs_bonus_loop_1:

	movem.l		(a7)+,d0-d7/a0-a4
	rts

;*******************************************Check Collision Me Vs Enemy1
;*
;*	Clecks the collision of enemy1 and player
;*
;********
col_me_vs_enemy1:
	movem.l		d0-d7/a0-a3,-(a7)
	move.w	bomblib::plx,d0
	move.w	bomblib::ply,d1

	move.w	bomblib::enemy1count,d7
	cmp.w	#0,d7
	ble		end_col_me_vs_enemy1_loop_1
	subq.w	#1,d7

	col_me_vs_enemy1_loop_1:
		move.w	d7,d6
		lea	bomblib::enemy1_x,a0		;Get enemy d6's x
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a2
		lea	bomblib::enemy1_y,a0		;Get enemy d6's y
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a3
		move.w	(a2),d2
		move.w	(a3),d3

		move.w	d0,d4
		move.w	d2,d5
		subq.w	#4,d4
		addq.w	#3,d5
		cmp.w	d4,d5
		bcs		col_me_vs_enemy1_no_col

		move.w	d0,d4
		move.w	d2,d5
		addq.w	#4,d4
		subq.w	#3,d5
		cmp.w	d4,d5
		bhi		col_me_vs_enemy1_no_col

		move.w	d1,d4
		move.w	d3,d5
		subq.w	#4,d4
		addq.w	#3,d5
		cmp.w	d4,d5
		bcs		col_me_vs_enemy1_no_col

		move.w	d1,d4
		move.w	d3,d5
		addq.w	#4,d4
		subq.w	#3,d5
		cmp.w	d4,d5
		bhi		col_me_vs_enemy1_no_col

			movem.l		(a7)+,d0-d7/a0-a3
			bra		i_have_died

		col_me_vs_enemy1_no_col:

		dbra.w	d7,col_me_vs_enemy1_loop_1
	end_col_me_vs_enemy1_loop_1:

	movem.l		(a7)+,d0-d7/a0-a3
	rts

;*******************************************Check Collision Enemy2 Vs Vexp
;*
;*	Clecks the collision of enemy2 and verticle explosion
;*
;********
col_en2_vs_vexp:
	movem.l		d0-d7/a0-a3,-(a7)
	move.w	bomblib::plx,d0
	move.w	bomblib::ply,d1

	move.w	bomblib::vexpcount,d7
	cmp.w	#0,d7
	ble		end_col_en2_vs_vexp_loop_2
	subq.w	#1,d7

	col_en2_vs_vexp_loop_2:
		move.w	d7,d6
		lea	bomblib::vexp_x,a0		;Get enemy d6's x
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a2
		lea	bomblib::vexp_y,a0		;Get enemy d6's y
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a3
		move.w	(a2),d0
		move.w	(a3),d1

		movem.l		d6-d7,-(a7)

			move.w	bomblib::enemy2count,d7
			cmp.w	#0,d7
			ble		end_col_en2_vs_vexp_loop_1
			subq.w	#1,d7

			col_en2_vs_vexp_loop_1:
				move.w	d7,d6
				lea	bomblib::enemy2_x,a0		;Get enemy d6's x
				move.w  d6,d2
				mulu.w	#2,d2
				lea	0(a0,d2.w),a2
				lea	bomblib::enemy2_y,a0		;Get enemy d6's y
				move.w  d6,d2
				mulu.w	#2,d2
				lea	0(a0,d2.w),a3
				move.w	(a2),d2
				move.w	(a3),d3

				move.w	d0,d4
				move.w	d2,d5
				subq.w	#3,d4
				addq.w	#3,d5
				cmp.w	d4,d5
				bcs		col_en2_vs_vexp_no_col

				move.w	d0,d4
				move.w	d2,d5
				addq.w	#3,d4
				subq.w	#3,d5
				cmp.w	d4,d5
				bhi		col_en2_vs_vexp_no_col

				move.w	d1,d4
				move.w	d3,d5
				subq.w	#4,d4
				addq.w	#3,d5
				cmp.w	d4,d5
				bcs		col_en2_vs_vexp_no_col

				move.w	d1,d4
				move.w	d3,d5
				addq.w	#4,d4
				subq.w	#3,d5
				cmp.w	d4,d5
				bhi		col_en2_vs_vexp_no_col

					jsr	bomblib::delete_enemy2
					add.w	#170,bomblib::score
					bsr		draw_score

				col_en2_vs_vexp_no_col:

				dbra.w	d7,col_en2_vs_vexp_loop_1
			end_col_en2_vs_vexp_loop_1:

		movem.l		(a7)+,d6-d7
		dbra.w	d7,col_en2_vs_vexp_loop_2
	end_col_en2_vs_vexp_loop_2:

	movem.l		(a7)+,d0-d7/a0-a3
	rts

;*******************************************Check Collision Enemy2 Vs Hexp
;*
;*	Clecks the collision of enemy2 and horizontal explosion
;*
;********
col_en2_vs_hexp:
	movem.l		d0-d7/a0-a3,-(a7)
	move.w	bomblib::plx,d0
	move.w	bomblib::ply,d1

	move.w	bomblib::hexpcount,d7
	cmp.w	#0,d7
	ble		end_col_en2_vs_hexp_loop_2
	subq.w	#1,d7

	col_en2_vs_hexp_loop_2:
		move.w	d7,d6
		lea	bomblib::hexp_x,a0		;Get enemy d6's x
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a2
		lea	bomblib::hexp_y,a0		;Get enemy d6's y
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a3
		move.w	(a2),d0
		move.w	(a3),d1

		movem.l		d6-d7,-(a7)

			move.w	bomblib::enemy2count,d7
			cmp.w	#0,d7
			ble		end_col_en2_vs_hexp_loop_1
			subq.w	#1,d7

			col_en2_vs_hexp_loop_1:
				move.w	d7,d6
				lea	bomblib::enemy2_x,a0		;Get enemy d6's x
				move.w  d6,d2
				mulu.w	#2,d2
				lea	0(a0,d2.w),a2
				lea	bomblib::enemy2_y,a0		;Get enemy d6's y
				move.w  d6,d2
				mulu.w	#2,d2
				lea	0(a0,d2.w),a3
				move.w	(a2),d2
				move.w	(a3),d3

				move.w	d0,d4
				move.w	d2,d5
				subq.w	#4,d4
				addq.w	#3,d5
				cmp.w	d4,d5
				bcs		col_en2_vs_hexp_no_col

				move.w	d0,d4
				move.w	d2,d5
				addq.w	#4,d4
				subq.w	#3,d5
				cmp.w	d4,d5
				bhi		col_en2_vs_hexp_no_col

				move.w	d1,d4
				move.w	d3,d5
				subq.w	#3,d4
				addq.w	#3,d5
				cmp.w	d4,d5
				bcs		col_en2_vs_hexp_no_col

				move.w	d1,d4
				move.w	d3,d5
				addq.w	#3,d4
				subq.w	#3,d5
				cmp.w	d4,d5
				bhi		col_en2_vs_hexp_no_col

					jsr	bomblib::delete_enemy2
					add.w	#170,bomblib::score
					bsr		draw_score

				col_en2_vs_hexp_no_col:

				dbra.w	d7,col_en2_vs_hexp_loop_1
			end_col_en2_vs_hexp_loop_1:

		movem.l		(a7)+,d6-d7
		dbra.w	d7,col_en2_vs_hexp_loop_2
	end_col_en2_vs_hexp_loop_2:

	movem.l		(a7)+,d0-d7/a0-a3
	rts

;*******************************************Check Collision Me Vs Enemy2
;*
;*	Clecks the collision of enemy2 and player explosion
;*
;********
col_me_vs_enemy2:
	movem.l		d0-d7/a0-a3,-(a7)
	move.w	bomblib::plx,d0
	move.w	bomblib::ply,d1

	move.w	bomblib::enemy2count,d7
	cmp.w	#0,d7
	ble		end_col_me_vs_enemy2_loop_1
	subq.w	#1,d7

	col_me_vs_enemy2_loop_1:
		move.w	d7,d6
		lea	bomblib::enemy2_x,a0		;Get enemy d6's x
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a2
		lea	bomblib::enemy2_y,a0		;Get enemy d6's y
		move.w  d6,d2
		mulu.w	#2,d2
		lea	0(a0,d2.w),a3
		move.w	(a2),d2
		move.w	(a3),d3

		move.w	d0,d4
		move.w	d2,d5
		subq.w	#4,d4
		addq.w	#3,d5
		cmp.w	d4,d5
		bcs		col_me_vs_enemy2_no_col

		move.w	d0,d4
		move.w	d2,d5
		addq.w	#4,d4
		subq.w	#3,d5
		cmp.w	d4,d5
		bhi		col_me_vs_enemy2_no_col

		move.w	d1,d4
		move.w	d3,d5
		subq.w	#4,d4
		addq.w	#3,d5
		cmp.w	d4,d5
		bcs		col_me_vs_enemy2_no_col

		move.w	d1,d4
		move.w	d3,d5
		addq.w	#4,d4
		subq.w	#3,d5
		cmp.w	d4,d5
		bhi		col_me_vs_enemy2_no_col

			movem.l		(a7)+,d0-d7/a0-a3
			bra		i_have_died

		col_me_vs_enemy2_no_col:

		dbra.w	d7,col_me_vs_enemy2_loop_1
	end_col_me_vs_enemy2_loop_1:

	movem.l		(a7)+,d0-d7/a0-a3
	rts