;*******************************************About Screen
;*
;*	This function is called in order to tell the player game information
;*
;*******
about_game:
	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)

	SetFont #2
	WriteStr	#10,#5,#1,_comment
	SetFont #1

	WriteStr	#20,#20,#1,bonus_1text
	WriteStr	#20,#30,#1,bonus_2text
	WriteStr	#20,#40,#1,bonus_3text
	WriteStr	#20,#50,#1,bonus_4text
	WriteStr	#20,#60,#1,bonus_5text
	WriteStr	#20,#70,#1,bonus_6text
	WriteStr	#20,#80,#1,bonus_7text
	WriteStr	#20,#90,#1,bonus_8text

	bsr		make_black_text

	PutGray4Sprite sprite_bonus10,sprite_bonus11,#10,#20
	PutGray4Sprite sprite_bonus20,sprite_bonus21,#10,#30
	PutGray4Sprite sprite_bonus30,sprite_bonus31,#10,#40
	PutGray4Sprite sprite_bonus40,sprite_bonus41,#10,#50
	PutGray4Sprite sprite_bonus50,sprite_bonus51,#10,#60
	PutGray4Sprite sprite_bonus60,sprite_bonus61,#10,#70
	PutGray4Sprite sprite_bonus70,sprite_bonus71,#10,#80
	PutGray4Sprite sprite_bonus80,sprite_bonus81,#10,#90

	bsr	idle_loop

	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)

	SetFont #2
	WriteStr	#10,#5,#1,_comment
	SetFont #1

	WriteStr	#20,#20,#1,bonus_9text

	bsr		make_black_text

	PutGray4Sprite sprite_bonus90,sprite_bonus91,#10,#20

	bsr	idle_loop

	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)

	SetFont #2
	WriteStr	#10,#5,#1,_comment
	SetFont #1

	WriteStr	#20,#23,#1,you_text
	WriteStr	#20,#36,#1,bomb_text
	WriteStr	#20,#47,#1,enemy1_text
	WriteStr	#20,#58,#1,enemy2_text

	bsr	make_black_text

	PutGray4Sprite sprite310,sprite311,#10,#20
	PutGray4Sprite sprite_bomb10,sprite_bomb11,#11,#35
	PutGray4Sprite sprite_enemy110,sprite_enemy111,#10,#46
	PutGray4Sprite sprite_enemy210,sprite_enemy211,#10,#57

	bsr	idle_loop

	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)

	SetFont #2
	WriteStr	#10,#5,#1,_comment
	SetFont #1

	WriteStr	#10,#30,#1,producer_text
	WriteStr	#15,#40,#1,producer
	WriteStr	#15,#50,#1,web_site
	WriteStr	#10,#70,#1,email_text
	WriteStr	#15,#80,#1,email

	bsr	make_black_text

	bsr	idle_loop

	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)

	SetFont #2
	WriteStr	#10,#5,#1,_comment
	SetFont #1
	WriteStr	#10,#30,#1,thanx_to
	SetFont #0
	WriteStr	#15,#40,#1,chris_iverson
	WriteStr	#15,#50,#1,nightswimmer
	WriteStr	#15,#60,#1,ccia
	SetFont #1
	bsr	make_black_text

	bsr	idle_loop
	bra	startup

;*******************************************Make the screen have black text
;*
;*	The text, when directly printed to the screen using WriteScreen, only displays
;*	the text in the first plane(grayscale).  It is needed to copy the data from the 
;*	first plane onto the second in order to make it black
;*
;*********
make_black_text:
	move.w	#1,d0
	move.w	#0,d1
	move.w	#29,d2
	move.w	#100,d3
	move.w	#0,graphlib::choosescreen	;set all graphlib functions to grayscale mode
	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr		graphlib::scrtomem
	move.w	#1,graphlib::choosescreen	;set all graphlib functions to grayscale mode
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr		graphlib::memtoscr
	rts