;******************************************Options Screen
;*
;*	Display the options screen and let the player choose different things
;*
;**********
options:
	;jsr		graphlib::gray2
	;move.w	#0,graphlib::choosescreen	;set all graphlib functions to grayscale mode

	Fill	#0,#47,#160,#13,#2

	SetFont	#2
	WriteStr	#29,#49,#0,game_options_text
	SetFont #1

	options_loop:

		Fill	#0,#60,#160,#40,#1

		WriteStr	#2,#64,#1,options_bullet_text
		WriteStr	#15,#64,#1,speed_options_text
		WriteStr	#100,#64,#1,rt_left_button_text

		move.w	game_speed,d0
		print_d0 #80,#64,#1
		bsr	idle_loop
		cmp	#264,d0
		beq	end_options
		cmp	#13,d0
		beq	end_options
		cmp	#337,d0
		beq	options_up
		cmp	#340,d0
		beq	options_down
		cmp	#338,d0
		beq	options_left
		cmp	#344,d0
		beq	options_right
		bra		options_loop

		options_up:			;right now there is only one option
			bra	options_loop
		options_down:			;right now there is only one option
			bra	options_loop
		options_left:			;right now there is only one option
			sub.w	#1,game_speed
			cmp.w	#0,game_speed
			bhi options_loop
			move.w	#1,game_speed
			bra	options_loop
		options_right:			;right now there is only one option
			add.w	#1,game_speed
			cmp.w	#15,game_speed
			bcs options_loop
			move.w	#14,game_speed
			bra	options_loop

end_options:
	move.w	game_speed,d0	;use the new gamespeed to calculate a new APD delay occurence
	mulu.w	#2,d0
	move.w	#3,d1
	add.w	d0,d1
	move.w	d1,def_t_to_APD

	;jsr		graphlib::gray4
	;move.w	#1,graphlib::choosescreen	;set all graphlib functions to grayscale mode

	bra	startup

game_options_text	dc.b	"Game Options",0,0
speed_options_text	dc.b	"Game Speed:",0

options_bullet_text	dc.b	22,0
game_speed		dc.w	3